function [sX,D] = normalize(X)
%------------------------------------------------------------------------%
% normalize the matrix X to have unit column vectors                     %
% (c) by Yuling Jiao (yulingjiaomath@whu.edu.cn)                         %
%         Bangti Jin (bangti.jin@gmail.com)                              %
% Created on March 17, 2013                                              %
%------------------------------------------------------------------------%
[n,p] = size(X);
d = 1./sqrt(ones(1,n)*X.^2);
D =  spdiags(d',0,p,p);
sX = X*D;